<?php
/**
* GOLDENFORMS version 1.0
* Copyright (c) 2012 Max @ GoldenForms.com, All rights reserved.
* Author: Max (GoldenForms.com)
* @license		GNU/GPL
* Visit http://www.GoldenForms.com for regular updates and information.
**/
Class GFEmail {
	
	function config(){
		$HtmlHelper = new HtmlHelper();
		echo $HtmlHelper->input('config[email][{N}][action_label]', array('type' => 'text', 'label' => 'Email Label', 'class' => 'big_input', 'smalldesc' => 'A label used to identify your email easily.'));
		echo $HtmlHelper->input('config[email][{N}][enabled]', array('type' => 'select', 'label' => 'Enabled', 'options' => array(0 => 'No', 1 => 'Yes'), 'smalldesc' => 'Enable or disable the email.'));
		echo $HtmlHelper->input('config[email][{N}][to]', array('type' => 'text', 'label' => 'To*', 'class' => 'big_input', 'smalldesc' => 'The email address to receive the email, can hold a comma separated list of addresses too.'));
		echo $HtmlHelper->input('config[email][{N}][subject]', array('type' => 'text', 'label' => 'Subject*', 'class' => 'big_input', 'smalldesc' => 'The subject of the email.'));
		echo $HtmlHelper->input('config[email][{N}][from_name]', array('type' => 'text', 'label' => 'From Name*', 'class' => 'big_input', 'smalldesc' => 'The name from which the email will be sent.'));
		echo $HtmlHelper->input('config[email][{N}][from_email]', array('type' => 'text', 'label' => 'From Email*', 'class' => 'big_input', 'smalldesc' => 'The email address from which the email will be sent, must be valid and preferably something@yourdomain.com'));
		echo $HtmlHelper->input('config[email][{N}][template]', array('type' => 'textarea', 'label' => 'Email Template', 'rows' => 20, 'cols' => 100, 'smalldesc' => 'Enter your email contents in HTML or Text, if you want to display the value of some field then enter the field name inside 2 curly brackets, you may use PHP code with tags'));
		echo $HtmlHelper->input('config[email][{N}][reply_name]', array('type' => 'text', 'label' => 'Reply To Name', 'class' => 'big_input', 'smalldesc' => 'The name which is going to appear when the resipient hits reply.'));
		echo $HtmlHelper->input('config[email][{N}][reply_email]', array('type' => 'text', 'label' => 'Reply to Email', 'class' => 'big_input', 'smalldesc' => 'The email address which is going to appear when the resipient hits reply, must be valid and preferably something@yourdomain.com'));
		echo $HtmlHelper->input('config[email][{N}][dto]', array('type' => 'text', 'label' => 'Dynamic To', 'class' => 'big_input', 'smalldesc' => 'A form field name holding an email address to be used as one of the recipient(s) address(es).'));
		echo $HtmlHelper->input('config[email][{N}][dsubject]', array('type' => 'text', 'label' => 'Dynamic Subject', 'class' => 'big_input', 'smalldesc' => 'A form field name holding the email subject.'));
		
	}
	
	function execute($form, $config = array(), $action_id = null){
		require_once(GOLDENFORMS_PATH.'classes'.DS.'actions'.DS.'email'.DS.'class.phpmailer.php');
		$mail = new PHPMailer();
		$config = new JParameter($config);
		ob_start();
		eval('?>'.$config->get('template', ''));
		$body = ob_get_clean();
		$body = $form->curly_replacer($body, $form->data, '.', true);
		//get recipient
		$tos = explode(',', trim($config->get('to', '')));
		foreach($tos as $to){
			$mail->AddAddress(trim($to));
		}
		$dtos = explode(',', trim($config->get('dto', '')));
		foreach($dtos as $dto){
			$mail->AddAddress($form->data($dto));
		}
		//subject
		$subject = trim($config->get('subject', '')) ? $config->get('subject', '') : $form->data($config->get('dsubject', ''));
		$mail->Subject = $subject;
		//from
		$from_name = trim($config->get('from_name', '')) ? $config->get('from_name', '') : $form->data($config->get('dfrom_name', ''));
		$from_email = trim($config->get('from_email', '')) ? $config->get('from_email', '') : $form->data($config->get('dfrom_email', ''));
		$mail->SetFrom($from_email, $from_name);
		//reply to
		$reply_name = trim($config->get('reply_name', '')) ? $config->get('reply_name', '') : $form->data($config->get('dreply_name', ''));
		$reply_email = trim($config->get('reply_email', '')) ? $config->get('reply_email', '') : $form->data($config->get('dreply_email', ''));
		if(!empty($reply_name) && !empty($reply_email)){
			$mail->AddReplyTo($reply_email, $reply_name);
		}
		if((bool)get_option('smtp') === true){
			$mail->IsSMTP();
			$mail->SMTPAuth   = true;
			$mail->Host       = get_option('smtp_host');
			$mail->Port       = get_option('smtp_port');
			$mail->Username   = get_option('smtp_username');
			$mail->Password   = get_option('smtp_password');
		}
		$mail->AltBody = 'To view the message, please use an HTML compatible email viewer!'; // optional - MsgHTML will create an alternate automatically
		$mail->MsgHTML($body);
		//$mail->AddAttachment('images/phpmailer.gif');

		if(!$mail->Send()){
			$form->errors[] = "Mailer Error: ".$mail->ErrorInfo;
		}else{
			//$form->display_error("Message sent!");
		}
	}
}