<?php
/**
* GOLDENFORMS version 1.0
* Copyright (c) 2012 Max @ GoldenForms.com, All rights reserved.
* Author: Max (GoldenForms.com)
* @license		GNU/GPL
* Visit http://www.GoldenForms.com for regular updates and information.
**/
class GfAdminController {

	function GfAdminController(){
		
	}
	
	function edit(){
		if(!empty($_POST['button_action'])){
			//process the form save/apply
			GfAdminController::save();
			if($_POST['button_action'] == 'Save'){
				//redirect
				wp_redirect('admin.php?page=golden-forms');exit;
			}else{
				$form_id = GfRequest::request('form_id', null);
				wp_redirect('admin.php?page=golden-forms-edit&form_id='.$form_id);exit;
			}
		}
		//pr($_POST);
		$form_id = GfRequest::request('form_id', null);
		if(!empty($form_id)){
			//load specified form data
			$form_data = GfAdminController::load_form_record($form_id);
			//pr($form_data);
		}
		include_once(GOLDENFORMS_PATH.'view'.DS.'edit.php');
	}
	
	function load_config($action, $action_id = null, $data = array()){
		$classname = 'GF'.GfAdminController::_camilize($action);		
		if(!class_exists($classname)){
			require_once(GOLDENFORMS_PATH.'classes'.DS.'actions'.DS.$action.DS.$action.'.php');					
		}
		ob_start();
		$classname::config();
		$config = ob_get_clean();
		if(!empty($action_id)){
			$config = str_replace('{N}', $action_id, $config);
			//republish data
			include_once(GOLDENFORMS_PATH.'classes'.DS.'data_republish.php');
			$HTMLFormPostDataLoad = new HTMLFormPostDataLoad();
			$config = $HTMLFormPostDataLoad->load($config, $data);
			echo $config;
		}else{
			echo $config;
		}
	}
	
	function _camilize($class = ''){
		$class = preg_replace('/(?:^|_)(.?)/e', "strtoupper('$1')", $class);
		return $class;
	}
	
	function save(){
		global $wpdb;
		$GfDb = &new GfDb();
		
		if(isset($_POST['params']) && !empty($_POST['params']) && is_array($_POST['params'])){
			$params = new JParameter('');
			foreach($_POST['params'] as $k => $v){
				if(is_array($v)){
					$v = implode(",", $v);
				}
				$params->set($k, $v);
			}
			GfRequest::set('params', $params->toString());
		}
		if(isset($_POST['extras']) && !empty($_POST['extras']) && is_array($_POST['extras'])){
			$base_string = new Base64String('');
			foreach($_POST['extras'] as $k => $v){
				//$_POST['extras'][$k] = base64_encode($v);
				$base_string->set($k, $v);
			}
			$_POST['extras'] = $base_string->toString();//serialize($_POST['extras']);
		}
		//get actions config
		$_POST['config'] = base64_encode(serialize($_POST['config']));
		
		$id = GfRequest::post('id', null);
		$GfRequest = GfRequest::fix_data();
		if(empty($id)){
			//new form, insert
			$wpdb->insert(
				$GfDb->gf_table, 
				array(
					'name' => GfRequest::post('name'),
					'form_type' => GfRequest::post('form_type'),
					'content' => GfRequest::post('content'),
					'extras' => GfRequest::post('extras'),
					'config' => GfRequest::post('config'),
					'params' => GfRequest::post('params'),
					'published' => GfRequest::post('published'),
				)
			);
			GfRequest::set('id', $wpdb->insert_id);
			GfRequest::set('form_id', $wpdb->insert_id);
		}else{
			//update
			$wpdb->update(
				$GfDb->gf_table, 
				array(
					'name' => GfRequest::post('name'),
					'form_type' => GfRequest::post('form_type'),
					'content' => GfRequest::post('content'),
					'extras' => GfRequest::post('extras'),
					'config' => GfRequest::post('config'),
					'params' => GfRequest::post('params'),
					'published' => GfRequest::post('published'),
				),
				array('id' => GfRequest::post('id', null))
			);
			GfRequest::set('form_id', GfRequest::post('id'));
		}
	}
	
	function load_form_record($form_id){
		global $wpdb;
		$GfDb = &new GfDb();
		$form_data = $wpdb->get_row($wpdb->prepare("SELECT * FROM `".$GfDb->gf_table."` WHERE `id` = '".$form_id."'"));
		$extras = new Base64String($form_data->extras);
		$form_data->extras = $extras->extract();
		$form_data->config = unserialize(base64_decode($form_data->config));
		return $form_data;
	}
	
	function index(){
		global $wpdb;
		$GfDb = &new GfDb();
		$forms = $wpdb->get_results($wpdb->prepare("SELECT * FROM `".$GfDb->gf_table."`"));
		include_once(GOLDENFORMS_PATH.'view'.DS.'index.php');
	}
	
	function settings(){
		$settings_data = array();
		$options = array('smtp', 'smtp_server', 'smtp_port', 'smtp_username', 'smtp_password');
		foreach($options as $opt){
			register_setting('golden_forms', $opt);
		}
		if(!empty($_POST)){			
			foreach($options as $opt){
				update_option($opt, $_POST[$opt]);
			}
		}
		//load saved settings
		foreach($options as $opt){
			$settings_data[$opt] = get_option($opt);
		}
		
		include_once(GOLDENFORMS_PATH.'view'.DS.'settings.php');
	}
	
	function delete($id = null){
		global $wpdb;
		$GfDb = &new GfDb();
		if(!empty($id)){
			$wpdb->query($wpdb->prepare("DELETE FROM `".$GfDb->gf_table."` WHERE `id` = '".$id."'"));
		}
	}
	
}