<?php
/**
* GOLDENFORMS version 1.0
* Copyright (c) 2012 Max @ GoldenForms.com, All rights reserved.
* Author: Max (GoldenForms.com)
* @license		GNU/GPL
* Visit http://www.GoldenForms.com for regular updates and information.
**/
class GfForm {
	var $params;
	var $data;
	var $events_actions = array();
	var $errors = array();
	var $form_output = '';
	var $stop = false;
	var $goto = null;

	function __construct($formname = ''){
		if(!empty($formname)){
			if((strpos($formname, "_virtual_form_") !== false) && (strpos($formname, "_virtual_form_") == 0)){
				//$this->getVForm($formname);
			}else{
				$this->getForm($formname);
			}
		}else{
			die('Form name can NOT be empty!');
		}
	}
	
	function &getInstance($formname = '', $reset = false){
		static $instances;
		if(!isset($instances)){
			$instances = array();
		}
		if(empty($instances[trim($formname)]) || $reset){
			$instances[trim($formname)] = new GfForm($formname);
			return $instances[trim($formname)];
		}else{
			return $instances[trim($formname)];
		}
	}
	
	function getForm($formname){
		if(!empty($formname)){
			global $wpdb;
			$GfDb = &new GfDb();
			$form_data = $wpdb->get_row($wpdb->prepare("SELECT * FROM `".$GfDb->gf_table."` WHERE `name` = '".$formname."' AND `published` = '1'"));
			if(!empty($form_data)){
				foreach($form_data as $k => $v){
					$this->$k = $v;
				}
				$this->params = new JParameter($form_data->params);
				$extras = new Base64String($form_data->extras);
				$this->extras = $extras->extract();
				$this->config = unserialize(base64_decode($form_data->config));
				$this->data = $this->get_data();
				$this->get_events_actions();
			}else{
				echo "Form not found or is not published";
			}
		}else{
			die("empty form name");
		}
	}
	
	function get_data(){
		return array_merge($_GET, $_POST);
	}
	
	function data($var = null, $default = null){
		if(empty($var)){
			return null;
		}
		if(isset($this->data[$var])){
			return $this->data[$var];
		}else{
			return $default;
		}
	}
		
	function process($task = 'load'){
		if(!empty($this->events_actions)){
			ob_start();
			foreach($this->events_actions[$task] as $action){
				if($this->stop === true){
					$this->stop = false;
					break;
				}
				if(isset($this->config[$action])){
					foreach($this->config[$action] as $action_id => $config){
						if(!isset($config['enabled']) || (isset($config['enabled']) && (bool)$config['enabled'] === true)){
							$this->runAction($action, $config, $action_id);
						}
					}
				}else{
					$this->runAction($action);
				}
			}
			$this->form_output = ob_get_clean();
			$this->display_errors();
			$this->display_output();
		}
		if(!empty($this->goto)){
			$goto = $this->goto;
			$this->goto = null;
			$this->run_event($goto);
		}
	}
	
	function run_event($event){
		$this->process($event);
	}
	
	function runAction($action, $config = array(), $action_id = null){
		$classname = 'GF'.$this->_camilize($action);		
		if(!class_exists($classname)){
			require_once(GOLDENFORMS_PATH.'classes'.DS.'actions'.DS.$action.DS.$action.'.php');					
		}
		//${$classname} = new $classname();
		$classname::execute($this, $config, $action_id);
	}
	
	function _camilize($class = ''){
		$class = preg_replace('/(?:^|_)(.?)/e', "strtoupper('$1')", $class);
		return $class;
	}
	
	function get_events_actions(){
		$this->events_actions = array(
			'load' => array(
				'load_captcha',
				'html',
				'credits',
			),
			'submit' => array(
				'check_captcha',
				'email',
				'thanks_message',
				'credits',
			)
		);
	}
	
	function display_output(){
		echo $this->form_output;
		$this->form_output = '';
	}
	
	function display_errors(){
		if(!empty($this->errors)){
			echo '<link rel="stylesheet" type="text/css" media="all" href="'.plugin_dir_url('goldenforms.php').'goldenforms/view/css/error.css" />';
			echo '<span class="gf_alert"><ol><li>'.implode('</li><li>', $this->_normalize($this->errors)).'</li></ol></span>';
		}
		$this->errors = array();
	}
	
	function _normalize($array = array()){
		$return = array();
		foreach($array as $k => $v){
			if(is_array($v)){
				$return = array_merge($this->_normalize($v), $return);
			}else{
				$return[] = $v;
			}
		}
		return $return;
	}
	
	function curly_replacer($content = '', $data = array(), $exploder = '.', $replace_null = false){
		preg_match_all('/{([^(}|{| )]*?)}/i', $content, $curly_matches);
		if(isset($curly_matches[1]) && !empty($curly_matches[1])){
			foreach($curly_matches[1] as $match){
				$value = $this->get_array_value($data, explode($exploder, $match));
				if(!is_null($value)){
					if(is_array($value)){
						$content = str_replace("{".$match."}", var_export($value, true), $content);
					}else{
						$content = str_replace("{".$match."}", $value, $content);
					}
				}else{
					if($replace_null === true){
						$content = str_replace("{".$match."}", '', $content);
					}
				}
			}
		}
		return $content;
	}
	
	function get_array_value($array, $indexes){
		if(count($indexes) == 1){
			if(is_array($array) && isset($array[$indexes[0]])){
				return $array[$indexes[0]];
			}else{
				return NULL;
			}
		}
		$index = array_shift($indexes);
		if($index == "[n]" && is_array($array)){
			//indexed numeric loop
			$data_array = array();
			foreach($array as $k => $v){
				$data_array[$k] = $this->get_array_value($array[$k], $indexes);
			}
			return $data_array;
		}else{
			if(isset($array[$index])){
				return $this->get_array_value($array[$index], $indexes);
			}else{
				return NULL;
			}
		}
	}
}