<?php
/*
 * Plugin Name: GoldenForms
 * Plugin URI: http://www.goldenforms.com
 * Description: Add any type of forms to your WordPress site quickly & effeciently and without any hassle, copy the HTML code of your form from any where (HTML editor, another web page source..etc), paste into GoldenForms, configure, Go!
 * Author: goldenforms.com
 * Author URI: http://www.goldenforms.com
 * Version: 1.0.0
 * License: GPL3
 * License URI: http://www.gnu.org/licenses/gpl.html
 */

global $GoldenForms_DBV;
$GoldenForms_DBV = '1.0.0';
define('DS', DIRECTORY_SEPARATOR);
require_once('classes'.DS.'gf_db.php');
require_once('classes'.DS.'gf_request.php');
require_once('classes'.DS.'admin_controller.php');
require_once('classes'.DS.'front_controller.php');
require_once('helpers'.DS.'parameter.php');
require_once('helpers'.DS.'base64_string.php');
require_once('classes'.DS.'gf_form.php');
$GfRequest = GfRequest::fix_data();
//multi purpose function
if(!function_exists('pr')){
	function pr($array = array()){
		echo '<pre>';
		print_r($array);
		echo '</pre>';
	}
}

class GoldenForms {
	
	function GoldenForms() {
		define('GOLDENFORMS_PATH', plugin_dir_path(__FILE__));
		define('GOLDENFORMS_URL', plugins_url('', __FILE__).'/');
		add_action('admin_init', array(&$this, 'init_admin')); //admin initializing
		add_action('init', array(&$this, 'init_global')); //global initializing
		add_action('admin_menu', array(&$this, 'gf_admin_menu')); //add the admin menu
		add_shortcode('GoldenForms', array(&$this, 'load_shortcode'));
	}
	
	function gf_admin_menu(){
		global $goldenForms_list, $goldenForms_settings;
		add_menu_page('Golden Forms', 'Golden Forms', 'administrator', "golden-forms", array(&$this, 'gf_admin_index'), plugins_url('view/images/golden-forms15.png', __FILE__));
		$goldenForms_list = add_submenu_page("golden-forms", 'Golden Forms', 'Forms List', 'administrator', "golden-forms", array(&$this, 'gf_admin_index'));
		$goldenForms_new = add_submenu_page("golden-forms", 'Golden Forms', 'New Form', 'administrator', "golden-forms-edit", array(&$this, 'gf_admin_edit'));
		$goldenForms_settings = add_submenu_page("golden-forms", 'Golden Forms', 'Settings', 'administrator', "golden-forms-settings", array(&$this, 'gf_admin_settings'));
		add_action('admin_print_styles-'.$goldenForms_list, array(&$this, 'print_GoldenForms_admin_styles'));
		add_action('admin_print_styles-'.$goldenForms_new, array(&$this, 'print_GoldenForms_admin_styles'));
		add_action('admin_print_styles-'.$goldenForms_settings, array(&$this, 'print_GoldenForms_admin_styles'));
	}
	
	function gf_admin_index(){
		GfAdminController::index();		
	}
	
	function gf_admin_edit(){		
		GfAdminController::edit();
	}
	
	function gf_admin_settings(){		
		GfAdminController::settings();
	}
	
	function init_admin(){
		wp_register_style('GoldenForms-style-admin-forms', plugins_url('view/css/admin_forms.css', __FILE__), false, '1.0', 'all');
		wp_register_style('GoldenForms-style-admin', plugins_url('view/css/admin.css', __FILE__), false, '1.0', 'all');
		$action = GfRequest::request('action', '');
		switch ($action){
			case 'delete':
				GfAdminController::delete(GfRequest::request('form_id', null));
				break;
		}
	}
	
	function init_global(){
		$form_name = GfRequest::request('gfname', null);
		if(!empty($form_name)){
			//GfFrontController::display_form($form_name);
		}
	}
	
	function load_shortcode($atts){
		extract(
			shortcode_atts(array(
				'gfname' => '',
				'gftask' => 'load'
			), $atts)
		);
		return GfFrontController::display_form($gfname, $gftask);
	}
	
	function print_GoldenForms_admin_styles(){
		wp_enqueue_style('GoldenForms-style-admin-forms');
		wp_enqueue_style('GoldenForms-style-admin');
	}

	function goldenforms_install(){
		$GfDb = &new GfDb();
		$GfDb->goldenforms_install();
	}
}

register_activation_hook(__FILE__, array('GoldenForms', 'goldenforms_install'));
//register_deactivation_hook(__FILE__, array('goldenForms', 'goldenforms_uninstall'));
$GoldenForms_instance = &new GoldenForms();