<?php
	wp_enqueue_script( 'jquery' );
	wp_enqueue_script( 'jquery-ui-core' );
	wp_enqueue_script( 'jquery-ui-tabs' );
	wp_enqueue_script( 'jquery-ui-dialog' );
?>

<script type="text/javascript" charset="utf8" >
	jQuery(document).ready(function($) {
		$("#details-panel").tabs();
	});
	function checkValid(){
		var patt1 = new RegExp(/^[a-zA-Z0-9_-]+$/);
		if(!patt1.test(jQuery('#gform_name').val())){
			alert("Please enter a valid form name with alphanumeric characters, underscore_ or a dash -.");
			return false;
		}else{
			return true;
		}
	}
</script>
<script>
	jQuery(document).ready(function($) {
		var $email_label_input = $( "#email_label")
		var email_count = $('#email_count').val();
		var action_count = $('#action_count').val();

		// tabs init with a custom tab template and an "add" callback filling in the content
		var $emails = $("#emails").tabs({
			tabTemplate: "<li><a href='#{href}'>#{label}</a> <span class='ui-icon ui-icon-close'>Remove</span></li>",
			add: function(event, ui){
				var tab_content = $('#email_generic_config').html().replace(/{N}/ig, action_count);//$tab_content_input.val() || "Tab " + email_count + " content.";
				$(ui.panel).append(tab_content);
			}
		});

		// modal dialog init: custom buttons and a "close" callback reseting the form inside
		var $add_email_dialog = $("#add_email_dialog").dialog({
			autoOpen: false,
			modal: true,
			buttons: {
				Add: function() {
					addTab();
					$( this ).dialog( "close" );
				},
				Cancel: function() {
					$( this ).dialog( "close" );
				}
			},
			open: function() {
				$email_label_input.focus();
			},
			close: function() {
				$('#email_label').val('');
			}
		});

		// addTab form: calls addTab function on submit and closes the dialog
		var $form = $("fieldset", $add_email_dialog).submit(function() {
			addTab();
			$add_email_dialog.dialog("close");
			return false;
		});

		// actual addTab function: adds new tab using the title input from the form above
		function addTab() {
			var email_label = $email_label_input.val() || "Email #" + email_count;
			$emails.tabs("add", "#emails-" + email_count, email_label);
			$('#configemail'+action_count+'action_label').val(email_label);
			email_count++;
			$('#email_count').val(email_count);
			action_count++;
			$('#action_count').val(action_count);
		}

		// addTab button: just opens the dialog
		$( "#add_email" ).button().click(function(){
			$add_email_dialog.dialog("open");
		});

		// close icon: removing the tab on click
		// note: closable tabs gonna be an option in the future - see http://dev.jqueryui.com/ticket/3924
		$("#emails span.ui-icon-close").live("click", function() {
			var index = $( "li", $emails ).index($(this).parent());
			$emails.tabs( "remove", index );
		});
	});
</script>
<?php
	include_once(GOLDENFORMS_PATH.'helpers'.DS.'html_helper.php');
	$HtmlHelper = new HtmlHelper();
	$HtmlHelper->data = $form_data;
	$params = new JParameter('');
	if(!empty($form_data)){
		$params = new JParameter($form_data->params);
	}	
?>

<form action="admin.php?page=golden-forms-edit&noheader=true" method="post" name="adminForm" id="adminForm" onsubmit="return checkValid();">
	<div class="buttons" style="text-align:right;">
		<input type="submit" value="Save" name="button_action" class="button-primary" style="min-width:50px;" />
		<input type="submit" value="Apply" name="button_action" class="button button-highlighted" style="min-width:50px;" />
	</div>
	<?php echo $HtmlHelper->input('id', array('type' => 'hidden')); ?>
	
	<div id="details-panel">
		<ul>
			<li><a href="#general">General Settings</a></li>
			<li><a href="#form-code">Form Code</a></li>
			<li><a href="#emails-panel">Emails Setup</a></li>
			<li><a href="#thanks-message">Thanks Message</a></li>
			<li><a href="#anti-spam">Anti Spam</a></li>
		</ul>
		<div id="general">
			<?php echo $HtmlHelper->input('name', array('type' => 'text', 'id' => 'gform_name', 'label' => 'Form name', 'class' => 'medium_input', 'smalldesc' => 'Unique form name without spaces or any special characters, underscores _ or dashes -')); ?>
			<?php echo $HtmlHelper->input('published', array('type' => 'select', 'label' => 'Published', 'options' => array(0 => 'No', 1 => 'Yes'), 'default' => 1)); ?>
			<?php //echo $HtmlHelper->input('params[auto_detect_settings]', array('type' => 'select', 'label' => 'Auto Detect Settings', 'value' => $params->get('auto_detect_settings', 1), 'options' => array(0 => 'No', 1 => 'Yes (Advised)'), 'default' => 1, 'smalldesc' => 'Should the form detect some settings and apply them automatically ? settings like validtaion and files uploading will be detected based on your form code.')); ?>
			<?php //echo $HtmlHelper->input('params[load_files]', array('type' => 'select', 'label' => 'Load Assets(JS/CSS)', 'value' => $params->get('load_files', 1), 'options' => array(0 => "Don't load any files", 1 => 'Load necessary files', 2 => 'Load ALL files!'), 'default' => 1)); ?>
			<?php echo $HtmlHelper->input('params[form_method]', array('type' => 'select', 'label' => 'Form method', 'value' => $params->get('form_method', 'post'), 'options' => array('post' => 'Post', 'get' => 'Get', 'file' => 'File'), 'default' => 'post', 'smalldesc' => 'Choose your form method, File is ncessary to get file uploads working.')); ?>
			<?php echo $HtmlHelper->input('params[action_url]', array('type' => 'text', 'label' => 'Submit URL', 'class' => 'big_input', 'value' => $params->get('action_url', ''), 'smalldesc' => 'Adding a submit URL will disable all the form auto functions like emails...etc')); ?>
			<?php echo $HtmlHelper->input('params[form_class]', array('type' => 'text', 'label' => 'Form Class', 'value' => $params->get('form_class', 'golden_form'), 'smalldesc' => 'The class attribute value for the generated form tag.')); ?>
			<?php echo $HtmlHelper->input('params[form_tag_attach]', array('type' => 'text', 'label' => 'Form tag attachment', 'class' => 'big_input', 'value' => htmlspecialchars($params->get('form_tag_attach', '')), 'smalldesc' => 'Some data you may like to include into the < form .... > tag, e.g: onsubmit="someJSFunction();".')); ?>
						
		</div>
		<div id="form-code">
			<?php echo $HtmlHelper->input('form_type', array('type' => 'hidden', 'label' => 'Form type', 'value' => 0, 'options' => array(0 => 'Custom', 1 => 'Wizard'), 'default' => 0, 'smalldesc' => 'Custom forms HTML code will not be affected when using it in the wizard, Wizard forms code will be overwritten though.')); ?>
			<?php echo $HtmlHelper->input('content', array('type' => 'textarea', 'label' => 'HTML code', 'rows' => 30, 'cols' => 100, 'smalldesc' => 'May contain PHP code with tags', 'value' => ($form_data ? htmlspecialchars($form_data->content) : ''))); ?>
			<?php echo $HtmlHelper->input('extras[css]', array('type' => 'textarea', 'label' => 'CSS code', 'rows' => 10, 'cols' => 100, 'smalldesc' => 'NO Style tags, May contain PHP code with tags', 'value' => ($form_data ? htmlspecialchars($form_data->extras[css]) : ''))); ?>
			<?php echo $HtmlHelper->input('extras[js]', array('type' => 'textarea', 'label' => 'JS code', 'rows' => 10, 'cols' => 100, 'smalldesc' => 'NO Script tags, May contain PHP code with tags', 'value' => ($form_data ? htmlspecialchars($form_data->extras[js]) : ''))); ?>
		</div>
		<div id="emails-panel">
			
			<div id="add_email_dialog" class="add_action_dialog" title="Email Label">
				<fieldset class="ui-helper-reset">
					<label for="email_label">Label</label>
					<input type="text" name="email_label" id="email_label" value="" class="ui-widget-content ui-corner-all" />
				</fieldset>
			</div>
			<a id="add_email" href="#" onClick="return false;">Add Email</a>

			<div id="emails" class="actions_tabs">
				<?php if(!empty($form_data->config['email'])): ?>
					<ul>
						<?php foreach($form_data->config['email'] as $k => $vs): ?>
							<li><a href="#emails-<?php echo $k; ?>"><?php echo !empty($form_data->config['email'][$k]['action_label']) ? $form_data->config['email'][$k]['action_label'] : "Email #".$k; ?></a> <span class="ui-icon ui-icon-close">Remove Tab</span></li>
						<?php endforeach; ?>
					</ul>
					<?php foreach($form_data->config['email'] as $k => $vs): ?>
						<div id="emails-<?php echo $k; ?>">
							<?php GfAdminController::load_config('email', $k, (array)$form_data); ?>
						</div>
					<?php endforeach; ?>
				<?php else: ?>
					<ul>
						<li><a href="#emails-1">Email #1</a> <span class="ui-icon ui-icon-close">Remove Tab</span></li>
					</ul>
					<div id="emails-1">
						<?php GfAdminController::load_config('email', 1, (array)$form_data); ?>
					</div>
				<?php endif; ?>
			</div>
		</div>
		<div id="thanks-message">
			<?php GfAdminController::load_config('thanks_message', 101, (array)$form_data); ?>
		</div>
		<div id="anti-spam">
			<?php GfAdminController::load_config('check_captcha', 103, (array)$form_data); ?>
			<?php GfAdminController::load_config('load_captcha', 102, (array)$form_data); ?>
		</div>
	</div>
</form>
<div id="email_generic_config" class="generic_action_config">
	<?php GfAdminController::load_config('email'); ?>
</div>
<?php
	$max_action_count = 2;
	if(!empty($form_data->config['email'])){
		foreach($form_data->config['email'] as $c => $d){
			if($c > $max_action_count){
				$max_action_count = $c;
			}
		}
	}
?>
<input name="action_count" id="action_count" value="<?php echo !empty($form_data->config['email']) ? count($form_data->config['email']) + 1 : 2; ?>" type="hidden" />
<input name="email_count" id="email_count" value="<?php echo !empty($form_data->config['email']) ? count($form_data->config['email']) + 1 : 2; ?>" type="hidden" />